# Issues
Please, only use the issue tracker for **problems, bugs and feature requests**.

For help with _implementing_ noUiSlider, please ask your question on [stackoverflow](https://stackoverflow.com/questions/tagged/nouislider). I try to look at questions posted there daily, and you will get you an answer much faster. Make sure to follow the [guidelines](https://stackoverflow.com/help/how-to-ask) of the platform.

While I'm happy to help if you can't figure something out, please note that I:
- Can't go and debug problems just based on screenshots;
- Can't help with issues that do not include **an example with code** that reproduces it;
- Won't dig through your production site or huge chunks of unrelated code;
- Won't implement your business requirements for you;

# Tooling

Please run the following tooling before submitting a pull request:

```bash
npm run lint
npm run format
```

# Pull requests
- Detail (in the pull request comment) what your changes do.
- When applicable, include new unit tests, and make sure existing ones pass.
- If you are introducing a new feature, update the **documentation**.
- Please don't commit `/distribute/*` files, I'll do that upon release.
